<script>
  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

  	//Importing scales and axis
	import { scaleBand, scaleLinear } from 'd3-scale';
	import { axisBottom, axisLeft } from 'd3-axis';
	import { select } from 'd3-selection';
	
	//Defining scales and axis
	const scaleX = scaleBand().domain(["Netflix", "Amazon Prime Video", "Disney+", "Hulu", "Apple TV", "Rakuten"]).range([0, 530]).padding(0.2);
	const scaleY=scaleLinear().domain([0, 3]).range([260, 0]);
	
	const axisX=axisBottom(scaleX);
	const axisY=axisLeft(scaleY);
	
	function xAxis(g){
		axisX(select(g))
	};
	
	function yAxis(g){
		axisY(select(g))
	};
</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`}>
    {#each data as datapoint}
		<rect width={scaleX.bandwidth()} height={innerHeight-scaleY(datapoint.viewers)} x={scaleX(datapoint.service)} y={scaleY(datapoint.viewers)} fill="steelblue" />
		{/each}
  </g>
	<g transform='translate({margin.left}, {height-margin.bottom})' use:xAxis></g>
	<g transform='translate({margin.left}, {margin.top})' use:yAxis></g>
  <g transform='translate({margin.left}, {margin.top}) rotate(270)' fill="none" font-size="10" font-family="sans-serif" text-anchor="middle">
    <text x="-130" y="-30" fill="currentcolor">Viewers (millions)</text>
	</g>
</svg>

